var dictionarySwitcher = {
	currentDict: "",
	dictMenu: {},
	panel: null,
	rememberMenuitem: null,
	list: [],
	langToDict: {},
	countryToDict: {},
	autoSucceeded: false,
	prefs: Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("spellchecker."),
	init: function() {
		if (!gURLBar)
			gURLBar = document.getElementById("urlbar");
		if (!gBrowser)
			gBrowser = document.getElementById("content");
		this.panel = document.getElementById("dictionary-switcher");
		this.l10n = document.getElementById("dictionary-switcher-l10n");
		this.rememberMenuitem = document.getElementById("dictionary-switcher-remember");
		this.menuseparator = document.getElementById("dictionary-switcher-menu").getElementsByTagName("menuseparator")[0];
		try {
			this.currentDict = this.prefs.getCharPref("dictionary");
		} catch(e) {}
		
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);
		
		var spellchecker = Components.classes["@mozilla.org/spellchecker/myspell;1"].createInstance(Components.interfaces.mozISpellCheckingEngine);
			spellchecker.getDictionaryList (this.list, {});
		this.list = this.list.value.toString().split(",");
		
		var menuitem = document.createElement("menuitem");
			menuitem.setAttribute("type", "radio");
			menuitem.setAttribute("name", "dictionary-switcher-dicts");
			menuitem.setAttribute("oncommand", "dictionarySwitcher.toggle(this.label)");
			for (var i=0; i < this.list.length; i++) {
				var code = this.list[i].split(/-|_/);
				this.langToDict[code[0]] = this.list[i];
				if (code[1])
					this.countryToDict[ code[1].toLowerCase() ] = this.list[i];
				menuitem = menuitem.cloneNode(true);
				menuitem.setAttribute("label", this.list[i]);
				this.dictMenu[this.list[i]] = menuitem;
				this.menuseparator.parentNode.insertBefore (menuitem, this.menuseparator);
			}
		
		var obj = this;
			gURLBar.addEventListener("ValueChange", function() {
				obj.pageSwitch();
			}, true);
			this._pageLoad = function(e) {
				obj.pageLoad(e);
			};
			this._keyPress = function(e) {
				obj.keyPress(e);
			};
			window.addEventListener("unload", function() {
				obj.prefs = null;
			}, false);

		this.getAutoPref();
		this.getAsITypePref();
		
		this.hostToDict = Components.utils.evalInSandbox(
			this.prefs.getCharPref("hostToDict"),
			new Components.utils.Sandbox("about:blank"));
		this.updateUI();
	},
	observe: function (subject, topic, data) {
		if (topic == "nsPref:changed") {
			switch (data) {
				case "dictionary":
					try {
						this.currentDict = this.prefs.getCharPref("dictionary");
					} catch(e) {
						this.currentDict = null;
					}
					this.updateUI();
					break;
				case "autoChangeDictionary":
					this.getAutoPref();
					if (this.auto)
						this.autoDetect(1,1);
					this.updateUI();
					break;
				case "detectDictionaryAsIType":
					this.getAsITypePref();
					break;
			}
		}
	},
	getAutoPref: function () {
		this.auto = this.prefs.getBoolPref("autoChangeDictionary");
		if (this.auto) {
			document.getElementById("dictionary-switcher-auto").setAttribute ("checked", "true");
			gBrowser.addEventListener("DOMContentLoaded", this._pageLoad, true);
		} else {
			document.getElementById("dictionary-switcher-auto").removeAttribute ("checked");
			gBrowser.removeEventListener("DOMContentLoaded", this._pageLoad, true);
		}
	},
	getAsITypePref: function () {
		this.asIType = this.prefs.getBoolPref("detectDictionaryAsIType");
		if (this.asIType) {
			document.getElementById("dictionary-switcher-as-i-type").setAttribute ("checked", "true");
			gBrowser.addEventListener("keypress", this._keyPress, true);
		} else {
			document.getElementById("dictionary-switcher-as-i-type").removeAttribute ("checked");
			gBrowser.removeEventListener("keypress", this._keyPress, true);
		}
	},
	canSpellCheck: function (node, doc) {
		return node && node.ownerDocument == doc && (node instanceof HTMLTextAreaElement || (node instanceof HTMLInputElement && node.type != "password")) && !node.readOnly;
	},
	keyPress: function (e) {
		if ((this.host && this.hostToDict[ this.host ]) || !this.canSpellCheck (e.originalTarget, gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document))
			return;
		var text = e.originalTarget.value;
		if (text.length == 10) {
			var editor = e.originalTarget.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor;
			if (editor) {
				var sc = editor.getInlineSpellChecker ?
					editor.getInlineSpellChecker(true) :
					editor.inlineSpellChecker;
				if (sc && sc.spellChecker) {
					text = text.split(/\W+/);
					var maxMisspelled = Math.round (text.length/4);
					var initialDict = sc.spellChecker.GetCurrentDictionary(), dict = initialDict;
					var misspelled, oldMisspelled, newDict;
					do {
						misspelled = 0;
						if (dict != initialDict)
							sc.spellChecker.SetCurrentDictionary(dict);
						for (var i = 0; i < text.length; i++)
							if (sc.spellChecker.CheckCurrentWord(text[i]))
								misspelled++;
						if (!newDict || misspelled < oldMisspelled)
							newDict = dict;
						oldMisspelled = misspelled;
						dict = this.getNextInList(dict);
					} while (misspelled > maxMisspelled && dict != initialDict);
					if (newDict && newDict != initialDict)
						this.toggle (newDict, true);
					else
						sc.spellChecker.SetCurrentDictionary (initialDict);
				}
			}
		}
	},
	tryRecheck: function () {
		var doc = gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document;
		var fields = [document.commandDispatcher.focusedElement]; // if a field is focused, recheck it
		if (!this.canSpellCheck(fields[0], doc))
			fields = doc.getElementsByTagName("textarea"); // otherwise recheck all textareas
		for (var i = 0; i < fields.length; i++) {
			if (!fields[i].readOnly) {
				var editor = fields[i].QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor;
				if (editor) {
					var sc = editor.getInlineSpellChecker ?
						editor.getInlineSpellChecker(true) :
						editor.inlineSpellChecker;
					if (sc && sc.spellChecker) {
						sc.spellChecker.SetCurrentDictionary(this.currentDict);
						sc.spellCheckRange(null);
					}
				}
			}
		}
	},
	setDict: function (dict, recheck) {
		if (!dict)
			return false;
		if (this.currentDict != dict) {
			this.prefs.setCharPref("dictionary", this.currentDict = dict);
			if (recheck)
				this.tryRecheck();
		}
		return true;
	},
	pageLoad: function (e) {
		if (e.originalTarget == gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document)
			this.autoDetect(0,1);
	},
	pageSwitch: function () {
		this.getHost();
		var dict = this.hostToDict[ this.host ];
		if (dict)
			this.setDict (dict);
		else
			this.autoDetect(1,1);
		this.updateUI();
	},
	autoDetect: function (checkHost, checkDocLang) {
		if (!this.auto)
			return;
		if (this.host && this.hostToDict[ this.host ])
			return;
		if (checkDocLang)
			this.autoSucceeded = this.autoDetectPerDocLang();
		if (this.host && checkHost && !this.autoSucceeded)
			this.autoSucceeded = this.autoDetectPerHost();
	},
	autoDetectPerHost: function () {
		return this.host ?
			this.setDict (this.countryToDict[ this.host.replace(/.*\./, "") ]) :
			false;
	},
	autoDetectPerDocLang: function () {
		var doc = gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document.documentElement;
		if (doc) {
			var lang = doc.getAttribute("lang") || doc.getAttribute("xml:lang");
			if (lang) {
				var i = this.list.indexOf(lang);
				return this.setDict (i < 0 ?
					this.langToDict[ lang.substr(0,2) ] :
					this.list[i], true);
			}
		}
		return false;
	},
	updateUI: function () {
		var saved = !! this.hostToDict[ this.host ];
		this.panel.label = (this.auto && this.autoSucceeded && !saved ? this.l10n.getString("autoDetected")+" " : "") + (this.currentDict || this.l10n.getString("noDict"));
		saved = saved.toString();
		this.panel.setAttribute ("saved", saved);
		this.rememberMenuitem.setAttribute ("checked", saved);
		if (this.dictMenu._last)
			this.dictMenu._last.removeAttribute ("checked");
		this.dictMenu._last = this.dictMenu[ this.currentDict ];
		if (this.dictMenu._last)
			this.dictMenu._last.setAttribute ("checked", true);
	},
	getNextInList: function (dict) {
		var i = this.list.indexOf(dict) + 1;
		if (i >= this.list.length)
			i = 0;
		return this.list[i];
	},
	toggle: function (dict, dontSave) {
		this.setDict (dict || this.getNextInList(this.currentDict), true);
		if (this.host && !dontSave) {
			this.hostToDict[ this.host ] = this.currentDict;
			this.syncHostList();
		}
	},
	toggleAuto: function () {
		this.prefs.setBoolPref("autoChangeDictionary", !this.auto);
	},
	toggleAsIType: function () {
		this.prefs.setBoolPref("detectDictionaryAsIType", !this.asIType);
	},
	toggleRemember: function () {
		if (this.host) {
			if (this.rememberMenuitem.getAttribute("checked") == "true")
				this.hostToDict[ this.host ] = this.currentDict;
			else {
				delete this.hostToDict[ this.host ];
				this.autoDetect(1,1);
			}
			this.syncHostList();
		}
	},
	syncHostList: function () {
		this.prefs.setCharPref("hostToDict", this.hostToDict.toSource());
		this.updateUI();
	},
	getHost: function () {
		var url = gURLBar.value.match(/\/\/(.*?)\//);
		this.host = url ? url[1] : null;
	}
};

window.addEventListener("load", function() {
	dictionarySwitcher.init();
}, false);