var dictionarySwitcher = {
	dictMenu: {},
	init: function() {
		this.panel = document.getElementById("dictionary-switcher");

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
		    .getService(Components.interfaces.nsIPrefService)
		    .getBranch("spellchecker.");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);

		var spellchecker = Components.classes["@mozilla.org/spellchecker/myspell;1"].createInstance(Components.interfaces.mozISpellCheckingEngine);
		spellchecker.getDictionaryList (this.list = {}, {});
		this.list = this.list.value.toString().split(",");

		var menu = document.getElementById("dictionary-switcher-menu");
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("type", "radio");
		menuitem.setAttribute("name", "dictionary-switcher-dicts");
		menuitem.setAttribute("oncommand", "dictionarySwitcher.toggle(this.label)");
		for (var i=0; i < this.list.length; i++) {
			menuitem = menuitem.cloneNode(true);
			menuitem.setAttribute("label", this.list[i]);
			this.dictMenu[this.list[i]] = menuitem;
			menu.appendChild (menuitem);
		}

		var obj = this;
		window.addEventListener("unload", function() {
			obj.prefs = null;
		}, false);
		GetCurrentEditorElement().addEventListener("load", function() {
			gMsgCompose.editor.addEditActionListener(obj.editActionListener);
			window.addEventListener("unload", function() {
				gMsgCompose.editor.removeEditActionListener(obj.editActionListener);
			}, false);
		}, true);

		this.updateUI(false);
	},
	editActionListener: {
		DidCreateNode: function (tag, node, parent, position, result) {},
		DidDeleteNode: function (child, result) {},
		DidDeleteSelection: function (selection) {},
		DidDeleteText: function (textNode, offset, length, result) {},
		DidInsertNode: function (node, parent, position, result) {},
		DidInsertText: function (textNode, offset, string, result) {},
		DidJoinNodes: function (leftNode, rightNode, parent, result) {},
		DidSplitNode: function (existingRightNode, offset, newLeftNode, result) {},
		WillCreateNode: function (tag, parent, position) {},
		WillDeleteNode: function (child) {},
		WillDeleteSelection: function (selection) {},
		WillDeleteText: function (textNode, offset, length) {},
		WillInsertNode: function (node, parent, position) {},
		WillInsertText: function (textNode, offset, string) {
			dictionarySwitcher.input(textNode);
		},
		WillJoinNodes: function (leftNode, rightNode, parent) {},
		WillSplitNode: function (existingRightNode, offset) {}
	},
	input: function (textNode) {
		if (textNode.length == 15) {
			var text = textNode.textContent.split(/\W+/);
			var sc = InlineSpellChecker.inlineSpellChecker.spellChecker;
			var maxMisspelled = Math.round (text.length/4);
			var dict = this.dict;
			var misspelled, oldMisspelled, newDict;
			do {
				misspelled = 0;
				if (dict != this.dict)
					sc.SetCurrentDictionary(dict);
				for (var i = 0; i < text.length; i++)
					if (sc.CheckCurrentWord(text[i]))
						misspelled++;
				if (!newDict || misspelled < oldMisspelled)
					newDict = dict;
				oldMisspelled = misspelled;
				dict = this.getNextInList(dict);
			} while (misspelled > maxMisspelled && dict != this.dict);
			if (newDict && newDict != this.dict)
				this.toggle (newDict, true);
			else
				sc.SetCurrentDictionary (this.dict);
		}
	},
	observe: function (subject, topic, data) {
		if (topic == "nsPref:changed" && data == "dictionary")
			this.updateUI(true);
	},
	updateUI: function (recheck) {
		this.panel.label = 
			this.dict = this.prefs.getCharPref("dictionary");
		if (this.dictMenu._last)
			this.dictMenu._last.removeAttribute ("checked");
		if (this.dictMenu._last = this.dictMenu[ this.dict ])
			this.dictMenu._last.setAttribute ("checked", true);
		if (recheck) {
			InlineSpellChecker.inlineSpellChecker.spellChecker.SetCurrentDictionary(this.dict);
			InlineSpellChecker.checkDocument(window.content.document);
		}
	},
	getNextInList: function (dict) {
		var i = this.list.indexOf(dict) + 1;
		if (i >= this.list.length)
			i = 0;
		return this.list[i];
	},
	toggle: function (dict) {
		this.prefs.setCharPref("dictionary", dict || this.getNextInList(this.dict));
	}
};

window.addEventListener("load", function() {
	dictionarySwitcher.init();
}, false);